# Referente a exposio Sesso 9
rm(list = ls())
while(search()[2] != "tools:rstudio") detach(2)

#Exemplo 2
# Carrega a biblioteca que possui o banco de exemplo e o banco de exemplo
library(MASS)
data(birthwt);ls()
?birthwt
# low: indicator of birth weight less than 2.5 kg.
# age: mother's age in years.
# lwt: mother's weight in pounds at last menstrual period.
# race: mother's race (1 = white, 2 = black, 3 = other).
# smoke: smoking status during pregnancy.
# ptl: number of previous premature labours.
# ht: history of hypertension.
# ui: presence of uterine irritability.
# ftv: number of physician visits during the first trimester.
# bwt: birth weight in grams.
# Verificar o contedo do banco

names(birthwt)
head(birthwt)

# Cria uma variavel indicadora de interao entre peso da mae e tabagismo
birthwt$pesomaefumo <- birthwt$lwt * birthwt$smoke

# plot(birthwt$pesomaefumo, birthwt$bwt)
# plot(birthwt$lwt, birthwt$bwt)
# plot(birthwt$smoke, birthwt$bwt)

# Modelos lineares simples comentrio sobre confuso
lm(bwt ~ lwt, data = birthwt)
lm(bwt ~ smoke, data = birthwt)
lm(bwt ~ lwt + smoke, data = birthwt)

# Modelo linear multiplo sem interao
reg1 <- lm(bwt ~ lwt + smoke, data = birthwt)
summary(reg1)

# Modelo linear multiplo com interao
reg2 <- lm(bwt ~ lwt + smoke + pesomaefumo, data = birthwt)
summary(reg2)

# Modelo linear multiplo com interao scificado dentro do modelo
reg3 <- lm(bwt ~ lwt + smoke + lwt * smoke, data = birthwt)
summary(reg3)

# Fazendo previses com equao completa e simplificada
lwt <- 120
smoke <- 1
Yt <- 2350.578 + 5.387 * lwt + 41.384 * smoke + -2.422 * lwt * smoke
Yc <- 2391.962 + 2.965 * lwt
Yt; Yc
smoke <- 0
Yt <- 2350.578 + 5.387 * lwt + 41.384 * smoke + -2.422 * lwt * smoke
Ys <- 2350.578 + 5.387 * lwt
Yt; Ys

# Mesma coisa coma funo predict
predict(reg3, newdata = data.frame(smoke = c(1,0), lwt = c(120,120)))
Yc; Ys

# library(rms)
# reg3 <- rms::ols(bwt ~ lwt + smoke + lwt * smoke, data = birthwt)
# dd <- datadist(birthwt)
# options(datadist = "dd")
# plot(summary(reg3))
# plot(nomogram(reg3))
# plot(Predict(reg3))

# Olhando as retas do ajuste linear
condition <- which(birthwt$smoke == 1)
plot(birthwt$lwt[condition], birthwt$bwt[condition],
     xlab = "Peso da me na ltima menstruao (em libras)",
     ylab = "Peso da criana (em g)",
     xlim = c(80,250), ylim = c(500,5000),
     col = "red")
condition <- which(birthwt$smoke == 0)
lines(birthwt$lwt[condition], birthwt$bwt[condition],
     , type = "p", col = "blue")
# abline(reg3)
abline(coef = c(2391.962 , 2.965), col = "blue")
abline(coef = c(2350.578 , 5.387), col = "red")
legend("bottomright", c("Tabagista","No tabagista"), lty = 1, col = c("red", "blue") )

##### Fazendo outro exemplo com interao significativa

# load("C:/Banco/idor/marianabrendim/dados/Mariana_predicao2.RData");ls()
# save(list = c("w", "pen.lmfit4"), file = "C:/Banco/curso_cpm/2019/data/FOIS_data.RData")
# Banco de dados em que o desfecho  diferena da escala FOIS final - inicial
# Inicial medida na internao e a final medida na alta
# Objetivo  prever que pacientes no melhoram (FOIS 0 ou negativa)
# dado que recebem sesses de fono dirias.
# w$registro <- 1:nrow(w)
# w$datanas <- NULL
# w$ruim <- NULL
# w$datainter <- NULL
# w$VM2alta <- NULL
# w$disfagiaAlta <- NULL
# w$SupNutriAlta <- NULL
# w$intercorrencia <- NULL
# View(w)
# save.image("C:/Banco/curso_cpm/2019/data/FOIS_data.RData");ls()

load("C:/Banco/curso_cpm/2019/data/FOIS_data.RData");ls()
library(rms)

# COndio pacientes somente como condie degenerativas
condition <- which(w$degen == "Degenerative")

# Primeiro grafico
par(mfrow = c(1,2))
plot(w$numSessions[condition], w$desfecho[condition],
     xlab = "Nmero de sesses",
     ylab = "Diferena da escala FOIS",
     xlim = c(0,100), ylim = c(-7,7),
     col = "red",
     main = "Grupo doena degenerativa")

# Simulando um banco de dados para realizar previses
z <- data.frame(FOISini = median(w$FOISini, na.rm = T),
                idade = median(w$idade, na.rm = T),
                degen = "Degenerative",
                lung = "No",
                disphagyaSev = "3",
                numSessions = 1:200)
# Adicionando a linha de previso
lines(1:200, predict(pen.lmfit4,z),
      col  = "red", lwd = 3)

# Condio e grafico d grupo de condio no degenerativo
condition <- which(w$degen == "Non degenerative")
plot(w$numSessions[condition], w$desfecho[condition],
     xlab = "Nmero de sesses ",
     ylab = "Diferena da escala FOIS",
     xlim = c(0,100), ylim = c(-7,7),
     col = "blue",
     main = "Grupo sem doena degenerativa")

# Adicionando a linha de previso para o grupo no degenerativo
z$degen <- "Non degenerative"
lines(1:200, predict(pen.lmfit4,z),
      col  = "blue", lwd = 3)
par(mfrow = c(1,1))

# Explicitando os valores fixos dos demais preditores
title(sub = paste0("Idade =",median(w$idade, na.rm = T),", Doena pulmonar = No, Escala disfagia = 3"), cex = 0.5)

# Mesma coisa com a funo Predict do pacote rms
# Esse assunto valtara na sesso 13
# library(rms)
dd <- datadist(w)
options(datadist = "dd")
plot(Predict(pen.lmfit4))
plot(Predict(pen.lmfit4, "numSessions", "degen"))

##### Explorando a interao pelo teste F: Coincidncia
reg1 <- lm(bwt ~ lwt, data = birthwt)
reg2 <- lm(bwt ~ lwt + smoke + lwt*smoke, data = birthwt)
anova(reg1,reg2)

##### Explorando a interao pelo teste F: Paralelismo
reg3 <- lm(bwt ~ lwt  + smoke, data = birthwt)
reg2 <- lm(bwt ~ lwt + smoke + lwt*smoke, data = birthwt)
anova(reg3,reg2)

###### Colinearidade
# Creiando um banco de dados ficticio com  n=100
# Onde h varias repeties da variavel idade com pequenas modificaes ou erros e so todas associadas com a varivel altura
# Para simular sempre o mesmo banco, estabelecer a semente fixa
set.seed(1)

# Criando um banco fictcio
height.dat <- data.frame(
  # idade
  age = age <- round(rnorm(100, mean=50, sd=10), 2),
  # copia exata da idade
  age2 = age,
  # Copia com algum erro
  age3 = age + rnorm(100, mean=0, sd=4),
  # Var desfecho que depende de idade com algum erro
  height = 20 + 3*age + rnorm(100, mean=0, sd=10)
)
rm(age)
head(height.dat)

# Verificando a cprrelao de Pearson
cor(height.dat)

# Funo definida no exemplo da funo pair() para colocar os valores de corerlao no painel do grafico
panel.cor <- function(x, y, digits = 2, prefix = "", cex.cor = 2, ...)
{
        usr <- par("usr"); on.exit(par(usr))
        par(usr = c(0, 1, 0, 1))
        r <- abs(cor(x, y))
        txt <- format(c(r, 0.123456789), digits = digits)[1]
        txt <- paste0(prefix, txt)
        if(missing(cex.cor)) cex.cor <- 0.8/strwidth(txt)
        text(0.5, 0.5, txt, cex = cex.cor)
}

# Explorando a colinearidade das idades visualmente
# O valor no painel superior  a correlao de Pearson
pairs(height.dat, lower.panel = panel.smooth, upper.panel = panel.cor, gap = 0, row1attop = FALSE)

# Regresses para cada preditor separadamente
reg4 <- lm(height ~ age, data = height.dat)
summary(reg4)

# Sada do reg 5 com age2 identica a age
reg5 <- lm(height ~ age2, data = height.dat)
summary(reg5)

# Sada do reg6 com age3, a idade com mais erro
# R2 e coeficiente menores
reg6 <- lm(height ~ age3, data = height.dat)
summary(reg6)

# Repare que a incluso de duas variveis colineares retorna o
# mesmo modelo reg4 ou reg5, a funo lm automaticamente desconsidera
# a variavel age2 por ser colinear com age
reg7 <- lm(height ~ age + age2, data = height.dat)
summary(reg7)

# Nessa combinao de age e age3, o coeficiente de age  um pouco acrescido
# e o coeficiente de age3 muda de direao e perde a significncia
# R2 continua elevado
reg8 <- lm(height ~ age + age3, data = height.dat)
summary(reg8)

# Um misto das situaes em reg8 e reg7
reg9 <- lm(height ~ age + age2 + age3, data = height.dat)
summary(reg9)

# Calculando vif a partir dos modelos
# install.packages("car")
car::vif(reg9)
car::vif(reg8)
car::vif(reg7)
# Alternativamente
rms::vif(reg9)
rms::vif(reg8)
rms::vif(reg7)

# Exerccio 3
rm(list = ls())
while(search()[2] != "tools:rstudio") detach(2)
load("D:/Banco/curso_cpm/2020/data/FOIS_data.RData");ls()

# 18. Explore a colinearidade das seguintes variveis... FOISini, idade, disphagyaSev, numSessions, desfecho. Marque as afirmativas corretas abaixo quanto as possveis interpretaes dessa explorao:
# Escolha uma ou mais:
#   a. H pelo menos uma varivel que poderia atrapalhar a construo de um modelo por conta de colinearidade.
# b. O ndice de colinearidade entre FOISini e o desfecho  de 0,56
# c. O ndice de colinearidade entre disphagyaSev e numSessions  de 0,56
# d. No h colinearidade detectada que poderia atrapalhar a construo de um modelo com esses preditores.

panel.cor <- function(x, y, digits = 2, prefix = "", cex.cor = 1.2, ...){
         usr <- par("usr"); on.exit(par(usr))
         par(usr = c(0, 1, 0, 1))
         r <- abs(cor(x, y))
         txt <- format(c(r, 0.123456789), digits = digits)[1]
         txt <- paste0(prefix, txt)
         if(missing(cex.cor)) cex.cor <- 0.8/strwidth(txt)
         text(0.5, 0.5, txt, cex = cex.cor)
}
pairs(w[,Hmisc::Cs(FOISini, idade, disphagyaSev, numSessions, desfecho)], lower.panel = panel.smooth, upper.panel = panel.cor, gap = 0, row1attop = FALSE, cex.labels = 1.2)

fit9 <- lm(desfecho ~ FOISini+ idade+ disphagyaSev+ numSessions, data = w)
car::vif(fit9)
rms::vif(fit9)

# 19. Faa um modelo linear com o dado w e a seguinte formula; desfecho ~ FOISini + idade + degen + lung + disphagyaSev+ VM2 + numSessions. Agora, faa cinco modelos lineares, cada um dos cinco com um dos seguintes termos de interao: FOISini * numSessions; idade * VM2; degen * disphagyaSev; degen * numSessions; lung * VM2. Qual a interao que mais aprimora o ajuste pelo R2 ajustado como medida de avaliao?
#   Escolha uma opo:
#   a. FOISini * numSessions
# b. idade * VM2
# c. degen * disphagyaSev
# d. degen * numSessions
# e. lung * VM2

fit10 <- lm(desfecho ~ FOISini + idade + degen + lung + disphagyaSev + VM2 + numSessions + FOISini * numSessions, data = w)
summary(fit10) # 0.5683
car::vif(fit10)
step(fit10)

fit11 <- lm(desfecho ~ FOISini + idade + degen + lung + disphagyaSev + VM2 + numSessions + idade * VM2, data = w)
summary(fit11) # 0.5708
step(fit11)
car::vif(fit11)

fit12 <- lm(desfecho ~ FOISini + idade + degen + lung + disphagyaSev + VM2 + numSessions + degen * disphagyaSev, data = w)
summary(fit12) # 0.5734
step(fit12)
car::vif(fit12)

fit13 <- lm(desfecho ~ FOISini + idade + degen + lung + disphagyaSev + VM2 + numSessions + degen * numSessions, data = w)
summary(fit13) # 0.5678
step(fit13)
car::vif(fit13)

fit14 <- lm(desfecho ~ FOISini + idade + degen + lung + disphagyaSev + VM2 + numSessions + lung * VM2, data = w)
summary(fit14) # 0.57
step(fit14)
car::vif(fit14)

summary(fit10)$adj.r.squared # FOISini * numSessions
summary(fit11)$adj.r.squared # idade * VM2
summary(fit12)$adj.r.squared # degen * disphagyaSev
summary(fit13)$adj.r.squared # degen * numSessions
summary(fit14)$adj.r.squared # lung * VM2

# 20. Faa um modelo linear com o dado w e a seguinte formula; desfecho ~ FOISini + idade + degen + lung + disphagyaSev + VM2 + numSessions. Agora, faa cinco modelos lineares, cada um dos cinco com um dos seguintes termos deinterao: FOISini * numSessions; idade * VM2; degen * disphagyaSev; degen * numSessions; lung * VM2. Quais desses termos de interao so retidos nos respectivos modelos finais pelo critrio de Akaike?
#   Escolha uma ou mais:
# a. FOISini * numSessions
# b. idade * VM2
# c. degen * disphagyaSev
# d. degen * numSessions
# e. lung * VM2

# 22. Repetindo os cinco modelos com diferentes termos de interao acima, faa um modelo linear com o dado w e a seguinte formula; desfecho ~ FOISini + idade + degen + lung + disphagyaSev + VM2 + numSessions. Agora, faa cinco modelos lineares, cada um dos cinco com um dos seguintes termos de interao: FOISini * numSessions; idade * VM2;degen * disphagyaSev; degen * numSessions; lung * VM2. Se testarmos a colinearidade pelo GVIF^(1/(2*Df)) (car::vif) dos mesmo cinco modelos com os termos de interao, qual deles no apresenta colinearidade com o limite de 10.
# Escolha uma ou mais:
#   a. FOISini * numSessions
# b. idade * VM2
# c. degen * disphagyaSev
# d. degen * numSessions
# e. lung * VM2


# 10 FOISini * numSessions # 0.5683   step: nao   GVIF^(1/(2*Df)): no
# 11 idade * VM2           # 0.5708   step: sim   GVIF^(1/(2*Df)): no
# 12 degen * disphagyaSev  # 0.5734   step: sim   GVIF^(1/(2*Df)): no
# 13 degen * numSessions   # 0.5678   step: sim   GVIF^(1/(2*Df)): no
# 14 lung * VM2            # 0.57     step: sim   GVIF^(1/(2*Df)): no

