##Sesso 5 - referente a sesso expositiva 4 - ANOVA

#######################
#Exemplo 1: Temperatura

fx18_20 <- c(98,98.4,97.7,98.5,97.1,97,98.2,97.3,97.7,98.0)
fx21_29 <- c(99.6,98.2,99,98.2,97.9,97,99.2,99.6,99)
fx30mais <- c(98.6,98.6,97,97.5,97.3,98.3,98,97.7,97,98.5,98.6)

temperatura <- c(fx18_20,fx21_29,fx30mais)
grupo <- c(rep("18 a 20 anos", length(fx18_20)),
           rep("21 a 29 anos", length(fx21_29)),
           rep("30 anos ou mais", length(fx30mais)))
banco <- data.frame(temperatura,grupo)

#descritiva
by(banco$temperatura,banco$grupo,mean)
by(banco$temperatura,banco$grupo,sd)
by(banco$temperatura,banco$grupo,summary)

#Anova
resultado <- aov(temperatura ~ grupo, data = banco)
summary(resultado)
coefficients(resultado)

# Homogeneidade de varincias
bartlett.test(temperatura ~ grupo, data = banco)

#Comparao Mltipla

#manualmente sem correo mltipla
t.test(temperatura ~ grupo, data = banco[banco$grupo != "30 anos ou mais",])
t.test(temperatura ~ grupo, data = banco[banco$grupo != "18 a 20 anos",])
t.test(temperatura ~ grupo, data = banco[banco$grupo != "21 a 29 anos",])

#p-valores com correo
# Se a varincia for diferente colocar pool.sd = F
pairwise.t.test(temperatura, grupo, p.adj = "bonf", data = banco, pool.sd = T)

pairwise.t.test(temperatura, grupo, p.adj = "holm", data = banco)

tu <- TukeyHSD(resultado)
tu
plot(tu)

####################################################
#Exemplo 2: Presso

# Pergunta 1: A mdia da varivel presso em geral e nos grupos 2 e 3 respectivamente so:
setwd("D:/Banco/curso_CPM/2020/data")
banco2 <- read.csv2("banco_pressao_anova.csv")
str(banco2)

banco2$grupo <- factor(banco2$grupo, labels = c("Feminino/cor negra", "Masculino/ cor negra", "Feminino/cor branca", "Masculino/ cor branca"))
table(banco2$grupo)

summary(banco2$pressao)
by(banco2$pressao,banco2$grupo,summary)

mean(banco2$pressao)
mean(banco2$pressao[banco2$grupo == "Masculino/ cor negra"])
mean(banco2$pressao[banco2$grupo == "Feminino/cor branca"])

# 7. Carregue o banco de dados "banco_pressao_anova.csv" e conduza uma anlise com a funo "bartlett.test" tendo a varivel "pressao" como desfecho e a varivel "grupo" como explicativa. Se a hiptese nula do teste  de que as varincias dos grupos so iguais (H0) ento:
# install.packages("car")
library(car)
car::leveneTest(pressao ~ grupo, data = banco2)
bartlett.test(pressao ~ grupo, data = banco2)
fligner.test(pressao ~ grupo, data = banco2)

# 8. Carregue o banco de dados "banco_pressao_anova.csv" e conduza uma anlise ANOVA com a funo "aov" tendo avarivel "pressao" como desfecho e a varivel "grupo" como explicativa (ateno que a varivel grupo deve estarformatada como fator e no como numrica). Na interpretao da sada dessa anlise:
# setwd("D:/Banco/curso_CPM/2020/data")
# banco2 <- read.csv2("banco_pressao_anova.csv")
# str(banco2)
resultado2 <- aov(pressao ~ grupo, data = banco2)
summary(resultado2)

tu2 <- TukeyHSD(resultado2)
plot(tu2)

pairwise.t.test(banco2$pressao,banco2$grupo, p.adj = "bonf", pool.sd = F)
