# Referentes as sessoes expositivas 6 e 7
rm(list = ls())
while(search()[2] != "tools:rstudio") detach(2)

# Sesso 8
library(foreign)

#Exemplo 1
setwd("F:/Banco/curso_CPM/2020/data")
setwd("C:/Banco/curso_CPM/2020/data")
setwd("D:/Banco/curso_CPM/2020/data")
banco <- read.spss("imunizacao_mortalidade_20 paises.sav", to.data.frame = TRUE)

str(banco)
banco

# Grfico de disperso
plot(banco$porc, banco$tm, col = "red", ylab = "Taxa de mortalidade por 1000 nasidos vivos",
     xlab = "Porcentagem Imunizada", cex = 2, cex.axis = 1.2, cex.lab = 1.2)

#Correlao de Pearson
cor(banco$porc, banco$tm)

# Teste de Hiptese da correlao
cor.test(banco$porc, banco$tm)

# Correlao de Spearman (no-paramtrico)
cor(banco$porc, banco$tm, method = "spearman")

#Teste de Hiptese da correlao
cor.test(banco$porc, banco$tm, method = "spearman")

#Exemplo 2
library(MASS)
data(birthwt)
names(birthwt)
head(birthwt)
plot(birthwt$lwt, birthwt$bwt, xlab = "Peso da me na ltima menst. (em lb)", ylab = "Peso ao nascer (em g)", col = "blue", lwd = 2, cex.axis = 1.5, cex.lab = 1.5)
reg <- lm(bwt ~ lwt, data = birthwt)
# plot(reg)
# plot(birthwt$bwt, predict(reg), ylim = c(1000,5000))
# abline(c(0,1), col = "red",lty = 2)
abline(reg, col = "red",lty = 2)

summary(aov(bwt ~ lwt, data = birthwt))
# ou
anova(lm(bwt ~ lwt, data = birthwt))
summary(reg)

# Sesso 7

# Carrega o a biblioteca MASS
library(MASS)

# Carrega os dados de exemplo
data(birthwt)

# Mostra os nomes das colunas do banco
names(birthwt)

# Modelos linear simples (peso)
regpeso <- lm(bwt ~ lwt, data = birthwt)
summary(regpeso)
predict(regpeso, newdata = data.frame(lwt = 150))
y <- 2369.624 + 4.429 * 150
y
predict(regpeso, data.frame(lwt = 160))
y <- 2369.624 + 4.429 * 160
y

# Modelo linear com 2 preditores (pacote stats)
regmult <- lm(bwt ~ lwt + age, data = birthwt)
summary(regmult)
anova(regmult)
aov(bwt ~ lwt + age, data = birthwt)
y <- 2214.412 + 4.177*160 + 8.089*20
y
y <- 2214.412 + 4.177*150 + 8.089*35
y

predict(regmult, data.frame(lwt = 160, age = 20))
predict(regmult, data.frame(lwt = 150, age = 20))
predict(regmult, data.frame(lwt = 150, age = 35))
predict(regmult, data.frame(lwt = c(150,150,160), age = c(20,20,35)))

plot(birthwt$lwt, birthwt$bwt, xlab = "Peso da me na ltima menst. (em lb)", ylab = "Peso ao nascer (em g)", col = "blue", lwd = 2, cex.axis = 1.5, cex.lab = 1.5)

lines(birthwt$lwt, predict(regmult, data.frame(lwt = birthwt$lwt, age = 20)))
lines(birthwt$lwt, predict(regmult, data.frame(lwt = birthwt$lwt, age = 30)))
lines(birthwt$lwt, predict(regmult, data.frame(lwt = birthwt$lwt, age = 40)))
lines(birthwt$lwt, predict(regmult, data.frame(lwt = birthwt$lwt, age = 50)))
lines(birthwt$lwt, predict(regmult, data.frame(lwt = birthwt$lwt, age = 120)))
lines(birthwt$lwt, predict(regmult, data.frame(lwt = birthwt$lwt, age = 12)))

# Inserindo uma varivel categrica binaria
regtabag2 <- lm(bwt ~ smoke, data = birthwt)
summary(regtabag2)
predict(regtabag2, data.frame(smoke = 1))
predict(regtabag2, data.frame(smoke = 0))

regtabag <- lm(bwt ~ factor(smoke), data = birthwt)
summary(regtabag)

# criando dummies
# 1 = white 2=black 3 = other
birthwt$corwhite <- ifelse(birthwt$race == 1, 1, 0)
birthwt$corblack <- ifelse(birthwt$race == 2, 1, 0)
summary(birthwt$corblack)
summary(birthwt$corwhite)

table(birthwt$corblack)
table(birthwt$corwhite)

#Regresso linear simples com raa
regraca <- lm(bwt ~ corwhite + corblack, data = birthwt)
summary(regraca)
anova(regraca)

# Formatando raa como fator
birthwt$race2 <- factor(birthwt$race, levels = c(3,1,2), labels = c("others","white", "black"))
# table(birthwt$race2, birthwt$race)

regraca2 <- lm(bwt ~ race2, data = birthwt)
summary(regraca2)
anova(regraca2)
predict(regraca2, data.frame(race2 = c("others","white", "black")))

# Testando se adio de tabagismo melhora o modelo F parcial
mod1 <- lm(bwt ~ age + lwt, data = birthwt)
mod2 <- lm(bwt ~ age + lwt + smoke, data = birthwt)
anova(mod1, mod2)

# Testando a adio de tabagismo no modelo de forma automatizada F parcial tipo 1
anova(mod2)

# Testando a adio de tabagismo no modelo de forma automatizada F parcial tipo2
# install.packages("car")
library(car)
Anova(mod2)

# Testando a adio de tabagismo no modelo de forma automatizada F parcial tipo2
# library(car)
Anova(mod2, type = 3)

# Comparando a saida do R2 simples e ajustado para multiplos preditores
mod0 <- lm(bwt ~ lwt, data = birthwt)
summary(mod0)
summary(mod1)
summary(mod2)
# summary(mod0)$r.squared;summary(mod1)$r.squared;summary(mod2)$r.squared

# Intrduzindo o conceito de AIC como seleo de modelo/preditores
reg <- lm(formula = bwt ~ lwt + race2 + age + smoke, data = birthwt)
AIC(reg)
# extractAIC(reg)

# Usa um mtodo de selo pelo AIC removenodo/colocando um preditor no modelo
step(reg)

# Fazendo previses do modelo final com Intervalos de confiana
# Poderia ser de qualquer modelo em que a funo genrica predict retorna o erro padro da previso
final <- step(reg)
# OU
final <- lm(formula = bwt ~ lwt + race2 + smoke, data = birthwt)
Y <- predict(final, se.fit = TRUE,
             newdata = data.frame(lwt = c(160,90),
                                  race2 =  c("black","white"),
                                  smoke = c(1,0)))
Y
Y$fit
Y$se.fit
# imprimindo bonitinho no console
sprintf("%1$4.1f [%2$4.1f-%3$4.1f]", Y$fit, Y$fit - 1.96*Y$se.fit, Y$fit + 1.96*Y$se.fit)

# Exercicio adicional
#Exemplo 2: Presso
# Remove todos os objetos da rea de trabalho
rm(list = ls())

setwd("F:/Banco/curso_CPM/2020/data")
setwd("D:/Banco/curso_CPM/2020/data")
banco2 <- read.csv2("banco_pressao_anova.csv")
str(banco2)

# ou
library(foreign)
banco <- read.spss("banco_imc_pressao.sav", to.data.frame = TRUE)

# Visualizando o banco
head(banco)
str(banco)
summary(banco)

# Defecho -> pressao_arterial
# Preditores -> idade imc habfumo
# habfumo = fumo formatado como fator
# table(banco$fumo, banco$habfumo)

# Editando o banco
# Botanod o IMC na escala correta
banco$imc <- banco$imc / 100
# Removendo os espaos em branco do tabagismo
banco$habfumo <- as.factor(trimws(banco$habfumo))

# Explorando a relao visualmente
# Idade
plot(banco$idade, banco$pressao_arterial, col = "red", xlab = "Idade",
     ylab = "Presso sanguinea", cex = 2, cex.axis = 1.2, cex.lab = 1.2)

# Indice de massa corporal
plot(banco$imc, banco$pressao_arterial, col = "red", xlab = "ndice de massa corpo",
     ylab = "Presso sanguinea", cex = 2, cex.axis = 1.2, cex.lab = 1.2)

# Tabagismo
by(banco$pressao_arterial,banco$habfumo,summary)

stripchart(banco$pressao_arterial ~ banco$habfumo, method = "jitter",
           vertical = TRUE, col = "red", xlab = "Tabagismo",
           ylab = "Presso sanguinea", cex = 2, cex.axis = 1.2, cex.lab = 1.2)

plot(banco$habfumo, banco$pressao_arterial, col = "red", xlab = "Tabagismo",
     ylab = "Presso sanguinea", cex = 2, cex.axis = 1.2, cex.lab = 1.2)

# Coeficiente de correlo de cada caso
# Idade
cor.test(banco$idade, banco$pressao_arterial)

# Indice de massa corporal
cor.test(banco$imc, banco$pressao_arterial)

# Tabagismo
chisq.test(table(banco$pressao_arterial,banco$habfumo))

# Modelos lineares simples
# idade
mod1 <- lm(pressao_arterial ~ idade, data = banco)
summary(mod1)

# Indice de massa corporal
mod2 <- lm(pressao_arterial ~ imc, data = banco)
summary(mod2)

# Tabagismo
mod3 <- lm(pressao_arterial ~ habfumo, data = banco)
summary(mod3)

# modelo cheio
mod4 <- lm(pressao_arterial ~ idade + imc + habfumo, data = banco)
summary(mod4)

# Anova do tipo I e II
anova(mod4)

library(car)
Anova(mod4)

# Minimizao do AIC
step(mod4)


############################################################
############################################################
# Exercicio com o banco FOIS
rm(list = ls())
graphics.off()
while(search()[2] != "tools:rstudio") detach(2)

# 1. O principal objetivo do trabalho que gerou esses dados era identificar quais seriam os pacientes que apresentariam melhora da deglutio pela escala FOIS ao final da internao, sendo que todos receberiam a mesma interveno. Carregue os dados FOIS_data.RData (o banco est no objeto w), e faa um grfico de disperso entre a escala FOIS inicial(FOISini) e FOIS final (FOISfim). Depois faa o mesmo grfico entre a escala FOIS inicial e a diferena (final - inicial) da escala FOIS (varivel desfecho). Responda a seguir sobre os possveis padres observados.
# Escolha uma opo:
  # a. No primeiro no h relao evidente, e no segundo h uma relao evidente positiva.
  # b. No primeiro no h relao evidente, e no segundo h uma relao evidente negativa.
  # c. No primeiro h relao evidente negativa, e no segundo h uma relao evidente negativa
  # d. No primeiro h relao evidente positiva, e no segundo h uma relao evidente negativa.

# Carregando a area de trabalho
load("D:/Banco/curso_cpm/2020/data/FOIS_data.RData");ls()
str(w)

plot(w$FOISini, w$FOISfim, col = "red", ylab = "Escala FOIS  alta", xlab = "Escala FOIS  internao", cex = 2, cex.axis = 1.2, cex.lab = 1.2)

plot(w$FOISini, w$desfecho, col = "red", ylab = "Diferena da escala FOIS final-inicial", xlab = "Escala FOIS  internao", cex = 2, cex.axis = 1.2, cex.lab = 1.2)

# plot(w$FOISini, w$idade, col = "red", ylab = "Idade  internao", xlab = "Escala FOIS  internao", cex = 2, cex.axis = 1.2, cex.lab = 1.2)
#
# plot(w$idade, w$desfecho, col = "red", ylab = "Idade  internao", xlab = "Escala FOIS  internao", cex = 2, cex.axis = 1.2, cex.lab = 1.2)

# Quais so os coeficientes de correlao de Pearson entre os pares FOIS inicial e FOIS e final, e FOIS inicial e diferena FOIS (final - inicial)
#Correlao de Pearson
# 0,051 e -0,560 <-
# -0,560 e 0,051
# 0.007 e -0,560
# 0.007 e -0.520
cor(w$FOISini, w$FOISfim)
cor(w$FOISini, w$desfecho)

# Teste de Hiptese da correlao
cor.test(w$FOISini, w$FOISfim)
cor.test(w$FOISini, w$desfecho)

# 3. Ajuste um modelo linear com o dado w tendo como preditor da varivel desfecho a varivel FOISini. A partir um summary do modelo, qual  a equao do modelo que permitiria estimar o valor do desfecho.
# Y <- 0.13194 + FOISini * -0.05835
# Y <- -0.93008 + FOISini * 4.38817
# Y <- 4.38817 + FOISini * -0.93008 # <-
# Y <- 4.38817 + FOISini * 0.13497

fit1 <- lm(desfecho ~ FOISini, data = w)
# anova(fit1)
summary(fit1)

# 4. Ajuste um modelo linear com o dado w tendo como preditor da varivel desfecho a varivel FOISini. Usando esse modelo linear para fazer previses quais seriam os valores das previses e o valor de FOIS final previsto para os valores de FOIS inicial de 3 e 6.
# previses = -1,2 e 2,5; FOIS final = 4,8 e 5,5
# previses = 4,8 e 5,5; FOIS final = -1,2 e 2.5
# previses = 2,5 e -1,2; FOIS final = 4,5 e 4,8 # <-
# previses = 2,5 e -1,2; FOIS final =  4,8 e 5,5

FOISini <- c(2,6)
Y <- 4.38817 + FOISini * -0.93008
Y
round(Y + FOISini,1)
# ou
Y <- predict(fit1, newdata = data.frame(FOISini = c(2,6)))
round(Y, 1)
round(Y + FOISini,1)

# 6. Ajuste um outro modelo para os mesmos dados, mas desta vez apenas com o preditor nmero de sesses defonoaudiologia (numSessions). Tomando como parmetro a qualidade do ajuste de modelos lineares pelo coeficiente de determinao, podemos concluir que o modelo com numSessions, em relao ao modelo com apenas FOISini...
# Escolha uma opo:
#   a. O modelo com numSessions possui uma qualidade de ajuste equivalente ao modelo com FOISini
# b. O modelo com numSessions possui uma qualidade de ajuste pior ao modelo com FOISini
# c. O modelo com numSessions possui uma qualidade de ajuste melhor ao modelo com FOISini

fit2 <- lm(desfecho ~ numSessions, data = w)
summary(fit2) # Pior

# 7. Ajuste um modelo mltiplo com os dados w, em que os preditores do desfecho so FOISini e numSessions. Qual  a equao que permite a previso do desfecho por esse modelo?
#   Escolha uma opo:
#   a. -0,959119 + -0,024092 * FOISini + 4,781216 * numSessions
# b. 4,781216 + -0,959119 * FOISini + -0,024092 * numSessions # <-
# c. -0,959119 + 4,781216 * FOISini + -0,024092 * numSessions
# d. -0,959119 * FOISini + 4,781216 * numSessions -0,024092

fit3 <- lm(desfecho ~ FOISini + numSessions, data = w)
summary(fit3)
anova(fit1, fit3)
Y <- 4.781216 + -0.959119 * FOISini + -0.024092 * numSessions

# 8. Para esse modelo de previso com FOISini e numSessions, qual  o valor mdio esperado do desfecho, isto , da diferena da escala FOIS final e inicial, se ambos FOISini e numSessions fossem igual a zero?
# 0,3405
# 0,1519
# -0,9591
# 4,7812 # <-
# 0,1514
FOISini = 0; numSessions = 0
Y <- 4.781216 + -0.959119 * FOISini + -0.024092 * numSessions
Y

# 9. Para esse modelo de previso com FOISini e numSessions, qual  o valor mdio esperado de mudana no desfecho, isto , na diferena da escala FOIS final e inicial, pra cada mudana de valor em FOISini?
# 0,3405
# 0,1519
# -0,9591 # <-
# 4,7812
# 0,1514

# 10. Para esse modelo de previso com FOISini e numSessions, qual  o valor mdio esperado no desfecho, isto , na diferena da escala FOIS final e inicial, se FOISini fosse 2 e numSessions fosse igual, 10, 15, 20.
# 2,4; 2,5; 2,6
# 2,4; 2,6; 2,5
# 2,6; 2,4; 2,5
# 2,6; 2,5; 2,4 # <-

FOISini = 2; numSessions = c(10,15,20)
Y <- 4.781216 + -0.959119 * FOISini + -0.024092 * numSessions
Y
predict(fit3, newdata = data.frame(FOISini = 2, numSessions = c(10,15,20)))

#11. Para esse modelo de previso com FOISini, numSessions e degen, qual  o efeito mdio esperado no desfecho, isto , na diferena da escala FOIS final e inicial, caso o paciente tenha uma doena degenerativa  internao.
fit4 <- lm(desfecho ~ FOISini + numSessions + degen, data = w)
summary(fit4)
# 3,72
# 1,56 # <-
# -0.94
# 0,422
# -0.025

#12. Para esse modelo de previso com FOISini, numSessions e degen, qual  o o valor previsto para a escala FOIS final  alta, caso o paciente tenha uma uma escala FOIS inicial de 2 e faa 18 sesses, e possa ter, como no ter doena degenerativa  internao.
# 1.39; 2.96
# 4.95; 3.39
# 3.39;  4.95 # <-
# 2.96; 1.39
Y <- predict(fit4, newdata = data.frame(FOISini = 2,
                                   numSessions = 18,
                                   degen = c("Degenerative","Non degenerative")))
round(Y + 2 ,2)

#13.  Com os dados w, ajuste uma modelo com os seguintes preditores: FOISini + idade + degen + lung + disphagyaSev + VM2 + SupNutri + numSessions. Aplicando-se um critrio pela anova parcial a 5% do modelo cheio para o vazio, qual  o modelo final que se chega?
# FOISini + idade + degen + lung + VM2
# FOISini + idade + degen + lung + disphagyaSev # <-
# FOISini + idade + degen + SupNutri + disphagyaSev
# idade + degen + lung + disphagyaSev

fit5 <- lm(desfecho ~ FOISini + idade + degen + lung + disphagyaSev + VM2 + SupNutri + numSessions, data = w)
anova(fit5)

# Automatizando a seleo de um novo modelo com a anova
x <- anova(fit5)
form <- attr(x,"row.names")[x$`Pr(>F)` <= 0.05]
form <- form[!is.na(form)]
form <- paste("desfecho ~",paste(form, collapse = " + "))
fit6 <- lm(as.formula(form), data = w)
fit6

#Ou manualmente
fit6 <- lm(desfecho ~ FOISini + idade + degen + lung + disphagyaSev, data = w)
anova(fit6)
summary(fit6)

# 14 Com os dados w, ajuste uma modelo com os seguintes preditores: FOISini + idade + degen + lung + disphagyaSev + VM2 + SupNutri + numSessions + FOISini * numSessions. Aplicando-se um critrio pela anova parcial do tipo 2 a 5% do modelo cheio para o vazio, qual  o modelo final que se chega?
# idade + degen + lung + VM2 + SupNutri
# FOISini + idade + degen + lung + disphagyaSev
# FOISini + idade + degen + lung + disphagyaSev + VM2
# idade + degen + lung + disphagyaSev # <-

library(car)
Anova(fit5)

x <- Anova(fit5)
form <- attr(x,"row.names")[x$`Pr(>F)` <= 0.05]
form <- form[!is.na(form)]
form <- paste("desfecho ~",paste(form, collapse = " + "))
fit7 <- lm(as.formula(form), data = w)
summary(fit7)

# ou
fit7 <- lm(desfecho ~ idade + degen + lung + disphagyaSev, data = w)
summary(fit7)

#15. Com os dados w, ajuste uma modelo com os seguintes preditores: FOISini + idade + degen + lung + disphagyaSev + VM2 + SupNutri + numSessions + FOISini * numSessions. Aplicando-se um critrio pela anova parcial do tipo 3 a 5% do modelo cheio para o vazio, qual  o modelo final que se chega?
# idade + degen + lung + VM2 + SupNutri
# FOISini + idade + degen + lung + disphagyaSev
# FOISini + idade + degen + lung + disphagyaSev + VM2
# idade + degen + lung + disphagyaSev # <-

# library(car)
Anova(fit5, type = 3)
# fit8 <- lm(desfecho ~ idade + degen + lung + disphagyaSev, data = w)
# summary(fit8)

# 16. Com os dados w, ajuste uma modelo com os seguintes preditores: FOISini + idade + degen + lung + disphagyaSev + VM2 + SupNutri + numSessions + FOISini * numSessions. Aplicando-se um critrio de Akaike a 5% do modelo cheio para o vazio, qual  o modelo final que se chega?
# idade + degen + lung + VM2 + SupNutri
# FOISini + idade + degen + lung + disphagyaSev
# FOISini + idade + degen + lung + disphagyaSev + VM2 # <-
# idade + degen + lung + disphagyaSev

fit8 <- step(fit5, direction = "backward")
Y <- predict(fit8, newdata = data.frame(FOISini = 2,
                                     idade = 78,
                                     lung = "No",
                                     disphagyaSev = as.factor(3),
                                     VM2 = "TCT",
                                     degen = c("Degenerative","Non degenerative")))
round(Y + 2, 1)

# 17. Com os dados w, ajuste uma modelo com os seguintes preditores: FOISini + idade + degen + lung + disphagyaSev + VM2 + SupNutri + numSessions ; e chegando-se a diferentes modelos finais com cada uma das estratgias de seleo, qaul dos modelos finais possui melhor desempenho pelo R2 ajustado.
# idade + degen + lung + VM2 + SupNutri
# FOISini + idade + degen + lung + disphagyaSev
# FOISini + idade + degen + lung + disphagyaSev + VM2 # <- Akaike
# idade + degen + lung + disphagyaSev

summary(fit6) # Anova
summary(fit7) # Anova 2 ou 3
summary(fit8) # Akaike

summary(fit6)$adj.r.squared
summary(fit7)$adj.r.squared
summary(fit8)$adj.r.squared

