# Script elaborado para fazer questes da avaliao 5 do curso, referente a medidas de desempenho
#

library(rms)

load("C:/Banco/curso_CPM/2019/data/Dados_para_avaliacao.RData");ls()
load("F:/Banco/curso_CPM/2019/data/Dados_para_avaliacao.RData");ls()
load("E:/Banco/curso_CPM/2019/data/Dados_para_avaliacao.RData");ls()
names(f)
View(f)
table(f$d)
summary(f)

# Modelo cheio
mod <- lrm(chagas ~ Q5.A2+Q6.A2+Q17.A2+Q18.A2+Q19.A2+Q20.A2+Q25.A2+rbbb+EV, data = f, x = T, y = T)
fastbw(mod) # Q17.A2 Q19.A2 Q20.A2 Q25.A2 rbbb   EV

# Modelo cheio nos dados de desenvolvimento
mod0 <- lrm(chagas ~ Q5.A2+Q6.A2+Q17.A2+Q18.A2+Q19.A2+Q20.A2+Q25.A2+rbbb+EV, data = f[f$set == "Development",], x = T, y = T)
mod0
x <- fastbw(mod0) # Q17.A2 Q18.A2 Q19.A2 Q20.A2 Q25.A2 rbbb   EV
x$names.kept

# Modelo selecionado nos dados de desenvolvimento
mod1 <- lrm(chagas ~ Q17.A2+Q18.A2+Q19.A2+Q20.A2+Q25.A2+rbbb+EV, data = f[f$set == "Development",], x = T, y = T)
mod1

# Estimativa do otimismo no modelo selecionado
valid_mod1 <- validate(mod1, B = 1000, set.seed(1))
valid_mod1

val.prob(y = mod1$y, logit = mod1$linear.predictors)

val.prob(y = f[f$set == "Validation", "chagas"], logit = predict(mod1, newdata = f[f$set == "Validation",]))
