##Aula resduos##

library(foreign)
banco<-read.spss("birthwt.sav")
banco$id<-1:189

reg<-lm(bwt~lwt,data=banco)

plot(banco$lwt,banco$bwt,xlab="Peso da me na ltima menst. (em lb)", ylab="Peso ao nascer (em g)",col="blue",lwd=2)
abline(reg,col="red",lty=2)

#Valores preditos (y chapeu) com intervalo de confiana

ychapeu<-predict(reg, banco, interval="confidence")    

#Resduo bruto

residuos<-resid(reg)

#Residuos x variavel explicativa

plot(banco$lwt, residuos, ylab="Residuos", xlab="Peso da me na ltima menstruao (em lb)", main="Resduos do peso ao nascer explicado pelo peso da me") 
abline(h=0,lty=2) 

#Residuos x valores preditos

ychapeus<-predict(reg, banco, interval=NULL)    #valores preditos sem intervalo de confiana

plot(ychapeus, residuos, ylab="Residuos", xlab="Valores preditos") 
abline(h=0,lty=2) 

#Resduo padronizado

residuopadronizado<-rstandard(reg) 

plot(banco$lwt, residuopadronizado, ylab="Residuos padronizados", xlab="Peso da me na ltima menstruao (em lb)", main="Resduos do peso ao nascer explicado pelo peso da me") 
abline(h=0,lty=2)  
abline(h=2,lty=2,col="red")  # limite superior
abline(h=-2,lty=2,col="red")  #limite inferior

#Resduo studentizado

residuostudentizado<-rstudent(reg) 

plot(ychapeus, residuostudentizado, ylab="Residuos studentizado", xlab="Valores preditos", main="Resduos do peso ao nascer explicado pelo peso da me") 
abline(h=0,lty=2)  
abline(h=2,lty=2,col="red")  # limite superior
abline(h=-2,lty=2,col="red")  #limite inferior
#Identificando os pontos
identify(ychapeus,residuostudentizado,labels=banco$id,plot=T)
#ou
residuostudentizado[residuostudentizado>2|residuostudentizado>(-2)]

#Verificando normalidade

#Grafico qqplot

qqnorm(residuopadronizado, ylab="Resduos padronizados", xlab="Escores z", main="Peso ao nascer") 
qqline(residuopadronizado)

#Histograma

hist(residuopadronizado)

#Boxplot

boxplot(residuopadronizado)

#Graficos automatizados

par(mfrow=c(2,2))
plot(reg)


